### Declares Behaviour Dictionaries ###

# Gets the (long) behaviour corresponding to a classification.
function get_behaviour_long(classification::BehaviourClass)
    haskey(known_behaviour_list,classification) ? known_behaviour_list[classification] : :unclassified_behaviour
end

# Gets the (short) behaviour corresponding to a behaviour or classification.
function get_behaviour(behaviour_or_classification)
    (behaviour_or_classification isa BehaviourClass) && return known_behaviour_list_short[get_behaviour_long(behaviour_or_classification)]
    (behaviour_or_classification isa Symbol) && return known_behaviour_list_short[behaviour_or_classification]
    error("Input to get_behaviour() is of an unknown type: $(typeof(behaviour_or_classification))")
end

# A list of classes with assigned behaviours.
const known_behaviour_list = Dict([
    (fp_type = :inactive, initial_activation_type = :NA,            deactivation_type = :NA, reactivation_type = :infinite) =>      :no_activation,
    (fp_type = :inactive, initial_activation_type = :NA,            deactivation_type = :NA, reactivation_type = :heterogeneous) => :stochastic_pulsing_no_initial_pulse,
    (fp_type = :inactive, initial_activation_type = :NA,            deactivation_type = :NA, reactivation_type = :instantaneous) => :regular_pulsing,
    (fp_type = :inactive, initial_activation_type = :infinite,      deactivation_type = :NA, reactivation_type = :infinite) =>      :no_activation,
    (fp_type = :inactive, initial_activation_type = :infinite,      deactivation_type = :NA, reactivation_type = :heterogeneous) => :stochastic_pulsing_no_initial_pulse,
    (fp_type = :inactive, initial_activation_type = :heterogeneous, deactivation_type = :NA, reactivation_type = :infinite) =>      :stochastic_pulsing_no_initial_pulse,
    (fp_type = :inactive, initial_activation_type = :heterogeneous, deactivation_type = :NA, reactivation_type = :heterogeneous) => :stochastic_pulsing_no_initial_pulse,
    (fp_type = :inactive, initial_activation_type = :heterogeneous, deactivation_type = :NA, reactivation_type = :instantaneous) => :regular_pulsing,
    (fp_type = :inactive, initial_activation_type = :instantaneous, deactivation_type = :NA, reactivation_type = :heterogeneous) => :stochastic_pulsing_initial_pulse,
    (fp_type = :inactive, initial_activation_type = :instantaneous, deactivation_type = :NA, reactivation_type = :instantaneous) => :regular_pulsing,
    (fp_type = :inactive, initial_activation_type = :pulse,         deactivation_type = :NA, reactivation_type = :infinite) =>      :single_response_pulse,
    (fp_type = :inactive, initial_activation_type = :pulse,         deactivation_type = :NA, reactivation_type = :heterogeneous) => :stochastic_pulsing_initial_pulse,
    (fp_type = :inactive, initial_activation_type = :pulse,         deactivation_type = :NA, reactivation_type = :instantaneous) => :regular_pulsing,
    
    (fp_type = :biunstability, initial_activation_type = :NA,               deactivation_type = :NA,            reactivation_type = :infinite) =>      :no_activation,
    (fp_type = :biunstability, initial_activation_type = :NA,               deactivation_type = :NA,            reactivation_type = :heterogeneous) => :stochastic_pulsing_no_initial_pulse,
    (fp_type = :biunstability, initial_activation_type = :NA,               deactivation_type = :NA,            reactivation_type = :instantaneous) => :regular_pulsing,
    (fp_type = :biunstability, initial_activation_type = :NA,               deactivation_type = :heterogeneous, reactivation_type = :heterogeneous) => :stochastic_switching,
    (fp_type = :biunstability, initial_activation_type = :heterogeneous,    deactivation_type = :NA,            reactivation_type = :heterogeneous) => :stochastic_pulsing_no_initial_pulse,
    (fp_type = :biunstability, initial_activation_type = :heterogeneous,    deactivation_type = :NA,            reactivation_type = :infinite) =>      :stochastic_pulsing_no_initial_pulse,
    (fp_type = :biunstability, initial_activation_type = :heterogeneous,    deactivation_type = :NA,            reactivation_type = :instantaneous) => :regular_pulsing,
    (fp_type = :biunstability, initial_activation_type = :instantaneous,    deactivation_type = :NA,            reactivation_type = :heterogeneous) => :stochastic_pulsing_no_initial_pulse,
    (fp_type = :biunstability, initial_activation_type = :instantaneous,    deactivation_type = :NA,            reactivation_type = :instantaneous) => :regular_pulsing,
    (fp_type = :biunstability, initial_activation_type = :heterogeneous,    deactivation_type = :heterogeneous, reactivation_type = :heterogeneous) => :stochastic_switching,
    (fp_type = :biunstability, initial_activation_type = :heterogeneous,    deactivation_type = :heterogeneous, reactivation_type = :infinite) =>      :stochastic_switching,
    (fp_type = :biunstability, initial_activation_type = :instantaneous,    deactivation_type = :NA,            reactivation_type = :infinite) =>      :oscillation,
    (fp_type = :biunstability, initial_activation_type = :instantaneous,    deactivation_type = :heterogeneous, reactivation_type = :heterogeneous) => :stochastic_switching_instant_initial_activation,
    (fp_type = :biunstability, initial_activation_type = :instantaneous,    deactivation_type = :heterogeneous, reactivation_type = :infinite) =>      :stochastic_switching_instant_initial_activation,
    (fp_type = :biunstability, initial_activation_type = :pulse,            deactivation_type = :NA,            reactivation_type = :infinite) =>      :single_response_pulse,
    (fp_type = :biunstability, initial_activation_type = :pulse,            deactivation_type = :NA,            reactivation_type = :heterogeneous) => :stochastic_pulsing_no_initial_pulse,
    (fp_type = :biunstability, initial_activation_type = :pulse,            deactivation_type = :NA,            reactivation_type = :instantaneous) => :regular_pulsing,
    (fp_type = :biunstability, initial_activation_type = :pulse,            deactivation_type = :heterogeneous, reactivation_type = :heterogeneous) => :stochastic_switching_instant_initial_activation,
    (fp_type = :biunstability, initial_activation_type = :pulse,            deactivation_type = :heterogeneous, reactivation_type = :infinite) =>      :stochastic_switching_instant_initial_activation,
    
    (fp_type = :bistability, initial_activation_type = :infinite,       deactivation_type = :infinite,      reactivation_type = :infinite) =>       :stable_bistability,
    (fp_type = :bistability, initial_activation_type = :infinite,       deactivation_type = :infinite,      reactivation_type = :heterogeneous) =>  :heterogeneous_activation,
    (fp_type = :bistability, initial_activation_type = :infinite,       deactivation_type = :heterogeneous, reactivation_type = :infinite) =>       :no_activation,
    (fp_type = :bistability, initial_activation_type = :infinite,       deactivation_type = :heterogeneous, reactivation_type = :heterogeneous) =>  :stochastic_switching,
    (fp_type = :bistability, initial_activation_type = :infinite,       deactivation_type = :instantaneous, reactivation_type = :infinite) =>       :no_activation,
    (fp_type = :bistability, initial_activation_type = :infinite,       deactivation_type = :instantaneous, reactivation_type = :heterogeneous) =>  :stochastic_pulsing_bistable_no_initial_pulse,
    (fp_type = :bistability, initial_activation_type = :heterogeneous,  deactivation_type = :infinite,      reactivation_type = :infinite) =>       :heterogeneous_activation,
    (fp_type = :bistability, initial_activation_type = :heterogeneous,  deactivation_type = :infinite,      reactivation_type = :heterogeneous) =>  :heterogeneous_activation,
    (fp_type = :bistability, initial_activation_type = :heterogeneous,  deactivation_type = :infinite,      reactivation_type = :instantaneous) =>  :heterogeneous_activation,
    (fp_type = :bistability, initial_activation_type = :heterogeneous,  deactivation_type = :heterogeneous, reactivation_type = :infinite) =>       :stochastic_switching,
    (fp_type = :bistability, initial_activation_type = :heterogeneous,  deactivation_type = :heterogeneous, reactivation_type = :heterogeneous) =>  :stochastic_switching,
    (fp_type = :bistability, initial_activation_type = :heterogeneous,  deactivation_type = :heterogeneous, reactivation_type = :instantaneous) =>  :stochastic_anti_pulsing_bistable_no_initial_activation,
    (fp_type = :bistability, initial_activation_type = :heterogeneous,  deactivation_type = :instantaneous, reactivation_type = :infinite) =>       :stochastic_pulsing_bistable_no_initial_pulse,
    (fp_type = :bistability, initial_activation_type = :heterogeneous,  deactivation_type = :instantaneous, reactivation_type = :heterogeneous) =>  :stochastic_pulsing_bistable_no_initial_pulse,
    (fp_type = :bistability, initial_activation_type = :heterogeneous,  deactivation_type = :instantaneous, reactivation_type = :instantaneous) =>  :oscillation_bistable,
    (fp_type = :bistability, initial_activation_type = :instantaneous,  deactivation_type = :infinite,      reactivation_type = :heterogeneous) =>  :homogeneous_activation,  
    (fp_type = :bistability, initial_activation_type = :instantaneous,  deactivation_type = :infinite,      reactivation_type = :instantaneous) =>  :homogeneous_activation,
    (fp_type = :bistability, initial_activation_type = :instantaneous,  deactivation_type = :heterogeneous, reactivation_type = :infinite) =>       :stochastic_switching_instant_initial_activation,
    (fp_type = :bistability, initial_activation_type = :instantaneous,  deactivation_type = :heterogeneous, reactivation_type = :heterogeneous) =>  :stochastic_switching_instant_initial_activation,
    (fp_type = :bistability, initial_activation_type = :instantaneous,  deactivation_type = :heterogeneous, reactivation_type = :instantaneous) =>  :stochastic_anti_pulsing_bistable,
    (fp_type = :bistability, initial_activation_type = :instantaneous,  deactivation_type = :instantaneous, reactivation_type = :heterogeneous) =>  :stochastic_pulsing_bistable_initial_pulse,
    (fp_type = :bistability, initial_activation_type = :instantaneous,  deactivation_type = :instantaneous, reactivation_type = :instantaneous) =>  :oscillation_bistable,
    (fp_type = :bistability, initial_activation_type = :pulse,          deactivation_type = :infinite,      reactivation_type = :heterogeneous) =>  :homogeneous_activation,
    (fp_type = :bistability, initial_activation_type = :pulse,          deactivation_type = :infinite,      reactivation_type = :instantaneous) =>  :homogeneous_activation,
    (fp_type = :bistability, initial_activation_type = :pulse,          deactivation_type = :heterogeneous, reactivation_type = :infinite) =>       :stochastic_switching_instant_initial_activation,
    (fp_type = :bistability, initial_activation_type = :pulse,          deactivation_type = :heterogeneous, reactivation_type = :heterogeneous) =>  :stochastic_switching_instant_initial_activation,
    (fp_type = :bistability, initial_activation_type = :pulse,          deactivation_type = :heterogeneous, reactivation_type = :instantaneous) =>  :stochastic_anti_pulsing_bistable,
    (fp_type = :bistability, initial_activation_type = :pulse,          deactivation_type = :instantaneous, reactivation_type = :heterogeneous) =>  :stochastic_pulsing_bistable_initial_pulse,
    (fp_type = :bistability, initial_activation_type = :pulse,          deactivation_type = :instantaneous, reactivation_type = :instantaneous) =>  :oscillation_bistable,
    
    (fp_type = :bistability_intermediary_active, initial_activation_type = :infinite,       deactivation_type = :infinite,      reactivation_type = :infinite) =>       :stable_bistability,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :infinite,       deactivation_type = :heterogeneous, reactivation_type = :infinite) =>       :no_activation,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :infinite,       deactivation_type = :heterogeneous, reactivation_type = :heterogeneous) =>  :stochastic_switching,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :infinite,       deactivation_type = :instantaneous, reactivation_type = :infinite) =>       :no_activation,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :infinite,       deactivation_type = :instantaneous, reactivation_type = :heterogeneous) =>  :stochastic_pulsing_bistable_no_initial_pulse,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :heterogeneous,  deactivation_type = :infinite,      reactivation_type = :infinite) =>       :heterogeneous_intermediate_activation_bistable,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :heterogeneous,  deactivation_type = :infinite,      reactivation_type = :heterogeneous) =>  :heterogeneous_intermediate_activation_bistable,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :heterogeneous,  deactivation_type = :infinite,      reactivation_type = :instantaneous) =>  :heterogeneous_intermediate_activation_bistable,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :heterogeneous,  deactivation_type = :heterogeneous, reactivation_type = :infinite) =>       :stochastic_switching,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :heterogeneous,  deactivation_type = :heterogeneous, reactivation_type = :heterogeneous) =>  :stochastic_switching,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :heterogeneous,  deactivation_type = :heterogeneous, reactivation_type = :instantaneous) =>  :stochastic_anti_pulsing_bistable_no_initial_activation,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :heterogeneous,  deactivation_type = :instantaneous, reactivation_type = :infinite) =>       :stochastic_pulsing_bistable_no_initial_pulse,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :heterogeneous,  deactivation_type = :instantaneous, reactivation_type = :heterogeneous) =>  :stochastic_pulsing_bistable_no_initial_pulse,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :heterogeneous,  deactivation_type = :instantaneous, reactivation_type = :instantaneous) =>  :oscillation_bistable,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :instantaneous,  deactivation_type = :infinite,      reactivation_type = :heterogeneous) =>  :homogeneous_intermediate_activation_bistable,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :instantaneous,  deactivation_type = :infinite,      reactivation_type = :instantaneous) =>  :homogeneous_intermediate_activation_bistable,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :instantaneous,  deactivation_type = :heterogeneous, reactivation_type = :infinite) =>       :stochastic_switching_instant_initial_activation,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :instantaneous,  deactivation_type = :heterogeneous, reactivation_type = :heterogeneous) =>  :stochastic_switching_instant_initial_activation,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :instantaneous,  deactivation_type = :heterogeneous, reactivation_type = :instantaneous) =>  :stochastic_anti_pulsing_bistable,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :instantaneous,  deactivation_type = :instantaneous, reactivation_type = :infinite) =>       :no_activation,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :instantaneous,  deactivation_type = :instantaneous, reactivation_type = :heterogeneous) =>  :stochastic_pulsing_bistable_initial_pulse,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :instantaneous,  deactivation_type = :instantaneous, reactivation_type = :instantaneous) =>  :oscillation_bistable,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :pulse,          deactivation_type = :infinite,      reactivation_type = :heterogeneous) =>  :homogeneous_intermediate_activation_bistable,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :pulse,          deactivation_type = :infinite,      reactivation_type = :instantaneous) =>  :homogeneous_intermediate_activation_bistable,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :pulse,          deactivation_type = :heterogeneous, reactivation_type = :infinite) =>       :stochastic_switching_instant_initial_activation,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :pulse,          deactivation_type = :heterogeneous, reactivation_type = :heterogeneous) =>  :stochastic_switching_instant_initial_activation,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :pulse,          deactivation_type = :heterogeneous, reactivation_type = :instantaneous) =>  :stochastic_anti_pulsing_bistable,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :pulse,          deactivation_type = :instantaneous, reactivation_type = :heterogeneous) =>  :stochastic_pulsing_bistable_initial_pulse,      
    (fp_type = :bistability_intermediary_active, initial_activation_type = :pulse,          deactivation_type = :instantaneous, reactivation_type = :instantaneous) =>  :oscillation_bistable,
    
    (fp_type = :active, initial_activation_type = :heterogeneous,   deactivation_type = :infinite,      reactivation_type = :NA) => :heterogeneous_activation_monostable,
    (fp_type = :active, initial_activation_type = :heterogeneous,   deactivation_type = :heterogeneous, reactivation_type = :NA) => :stochastic_anti_pulsing_no_initial_activation,
    (fp_type = :active, initial_activation_type = :heterogeneous,   deactivation_type = :instantaneous, reactivation_type = :NA) => :regular_anti_pulsing_no_initial_activation,
    (fp_type = :active, initial_activation_type = :instantaneous,   deactivation_type = :infinite,      reactivation_type = :NA) => :homogeneous_activation,
    (fp_type = :active, initial_activation_type = :instantaneous,   deactivation_type = :heterogeneous, reactivation_type = :NA) => :stochastic_anti_pulsing,
    (fp_type = :active, initial_activation_type = :instantaneous,   deactivation_type = :instantaneous, reactivation_type = :NA) => :regular_anti_pulsing,
    (fp_type = :active, initial_activation_type = :pulse,           deactivation_type = :infinite,      reactivation_type = :NA) => :homogeneous_activation,
    (fp_type = :active, initial_activation_type = :pulse,           deactivation_type = :heterogeneous, reactivation_type = :NA) => :stochastic_anti_pulsing,
    (fp_type = :active, initial_activation_type = :pulse,           deactivation_type = :instantaneous, reactivation_type = :NA) => :regular_anti_pulsing,
    
    (fp_type = :oscillation_inactive_ss, initial_activation_type = :NA,             deactivation_type = :NA, reactivation_type = :infinite) =>       :no_activation,
    (fp_type = :oscillation_inactive_ss, initial_activation_type = :NA,             deactivation_type = :NA, reactivation_type = :heterogeneous) =>  :stochastic_pulsing,
    (fp_type = :oscillation_inactive_ss, initial_activation_type = :NA,             deactivation_type = :NA, reactivation_type = :instantaneous) =>  :regular_pulsing,
    (fp_type = :oscillation_inactive_ss, initial_activation_type = :infinite,       deactivation_type = :NA, reactivation_type = :heterogeneous) =>  :oscillation,
    (fp_type = :oscillation_inactive_ss, initial_activation_type = :infinite,       deactivation_type = :NA, reactivation_type = :infinite) =>       :oscillation,
    (fp_type = :oscillation_inactive_ss, initial_activation_type = :heterogeneous,  deactivation_type = :NA, reactivation_type = :infinite) =>       :oscillation,
    (fp_type = :oscillation_inactive_ss, initial_activation_type = :heterogeneous,  deactivation_type = :NA, reactivation_type = :heterogeneous) =>  :oscillation,
    (fp_type = :oscillation_inactive_ss, initial_activation_type = :heterogeneous,  deactivation_type = :NA, reactivation_type = :instantaneous) =>  :regular_pulsing,
    (fp_type = :oscillation_inactive_ss, initial_activation_type = :instantaneous,  deactivation_type = :NA, reactivation_type = :infinite) =>       :oscillation,
    (fp_type = :oscillation_inactive_ss, initial_activation_type = :instantaneous,  deactivation_type = :NA, reactivation_type = :heterogeneous) =>  :oscillation,
    (fp_type = :oscillation_inactive_ss, initial_activation_type = :instantaneous,  deactivation_type = :NA, reactivation_type = :instantaneous) =>  :regular_pulsing,
    (fp_type = :oscillation_inactive_ss, initial_activation_type = :pulse,          deactivation_type = :NA, reactivation_type = :infinite) =>       :oscillation,
    (fp_type = :oscillation_inactive_ss, initial_activation_type = :pulse,          deactivation_type = :NA, reactivation_type = :heterogeneous) =>  :stochastic_pulsing,
    (fp_type = :oscillation_inactive_ss, initial_activation_type = :pulse,          deactivation_type = :NA, reactivation_type = :instantaneous) =>  :regular_pulsing,
    
    (fp_type = :oscillation_intermediary_ss, initial_activation_type = :infinite,       deactivation_type = :infinite,      reactivation_type = :infinite) =>       :homogeneous_intermediate_activation,
    (fp_type = :oscillation_intermediary_ss, initial_activation_type = :infinite,       deactivation_type = :heterogeneous, reactivation_type = :infinite) =>       :oscillation,
    (fp_type = :oscillation_intermediary_ss, initial_activation_type = :infinite,       deactivation_type = :instantaneous, reactivation_type = :infinite) =>       :oscillation,
    (fp_type = :oscillation_intermediary_ss, initial_activation_type = :heterogeneous,  deactivation_type = :infinite,      reactivation_type = :infinite) =>       :oscillation,
    (fp_type = :oscillation_intermediary_ss, initial_activation_type = :heterogeneous,  deactivation_type = :heterogeneous, reactivation_type = :infinite) =>       :oscillation,
    (fp_type = :oscillation_intermediary_ss, initial_activation_type = :heterogeneous,  deactivation_type = :instantaneous, reactivation_type = :heterogeneous) =>  :oscillation,
    (fp_type = :oscillation_intermediary_ss, initial_activation_type = :heterogeneous,  deactivation_type = :instantaneous, reactivation_type = :instantaneous) =>  :oscillation,
    (fp_type = :oscillation_intermediary_ss, initial_activation_type = :instantaneous,  deactivation_type = :infinite,      reactivation_type = :infinite) =>       :oscillation, # :homogeneous_intermediate_activation,
    (fp_type = :oscillation_intermediary_ss, initial_activation_type = :instantaneous,  deactivation_type = :infinite,      reactivation_type = :heterogeneous) =>  :oscillation,
    (fp_type = :oscillation_intermediary_ss, initial_activation_type = :instantaneous,  deactivation_type = :infinite,      reactivation_type = :instantaneous) =>  :oscillation, # :homogeneous_intermediate_activation,
    (fp_type = :oscillation_intermediary_ss, initial_activation_type = :instantaneous,  deactivation_type = :heterogeneous, reactivation_type = :instantaneous) =>  :oscillation,
    (fp_type = :oscillation_intermediary_ss, initial_activation_type = :instantaneous,  deactivation_type = :heterogeneous, reactivation_type = :heterogeneous) =>  :oscillation, # :homogeneous_intermediate_activation,
    (fp_type = :oscillation_intermediary_ss, initial_activation_type = :instantaneous,  deactivation_type = :heterogeneous, reactivation_type = :infinite) =>       :oscillation,
    (fp_type = :oscillation_intermediary_ss, initial_activation_type = :instantaneous,  deactivation_type = :instantaneous, reactivation_type = :infinite) =>       :oscillation,
    (fp_type = :oscillation_intermediary_ss, initial_activation_type = :instantaneous,  deactivation_type = :instantaneous, reactivation_type = :heterogeneous) =>  :stochastic_pulsing_no_initial_pulse,
    (fp_type = :oscillation_intermediary_ss, initial_activation_type = :instantaneous,  deactivation_type = :instantaneous, reactivation_type = :instantaneous) =>  :oscillation,
    (fp_type = :oscillation_intermediary_ss, initial_activation_type = :pulse,          deactivation_type = :infinite,      reactivation_type = :infinite) =>       :oscillation, # :homogeneous_intermediate_activation,
    (fp_type = :oscillation_intermediary_ss, initial_activation_type = :pulse,          deactivation_type = :infinite,      reactivation_type = :heterogeneous) =>  :oscillation,
    (fp_type = :oscillation_intermediary_ss, initial_activation_type = :pulse,          deactivation_type = :infinite,      reactivation_type = :instantaneous) =>  :oscillation, # :homogeneous_intermediate_activation,
    (fp_type = :oscillation_intermediary_ss, initial_activation_type = :pulse,          deactivation_type = :heterogeneous, reactivation_type = :infinite) =>       :oscillation,
    (fp_type = :oscillation_intermediary_ss, initial_activation_type = :pulse,          deactivation_type = :heterogeneous, reactivation_type = :heterogeneous) =>  :oscillation, # :homogeneous_intermediate_activation,
    (fp_type = :oscillation_intermediary_ss, initial_activation_type = :pulse,          deactivation_type = :heterogeneous, reactivation_type = :instantaneous) =>  :oscillation,
    (fp_type = :oscillation_intermediary_ss, initial_activation_type = :pulse,          deactivation_type = :instantaneous, reactivation_type = :infinite) =>       :oscillation,
    (fp_type = :oscillation_intermediary_ss, initial_activation_type = :pulse,          deactivation_type = :instantaneous, reactivation_type = :heterogeneous) =>  :oscillation, # :homogeneous_intermediate_activation,
    (fp_type = :oscillation_intermediary_ss, initial_activation_type = :pulse,          deactivation_type = :instantaneous, reactivation_type = :instantaneous) =>  :oscillation,
    
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :infinite,       deactivation_type = :heterogeneous, reactivation_type = :infinite) =>       :no_activation,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :infinite,       deactivation_type = :heterogeneous, reactivation_type = :heterogeneous) =>  :oscillation, # :stochastic_switching,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :infinite,       deactivation_type = :instantaneous, reactivation_type = :infinite) =>       :no_activation,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :heterogeneous,  deactivation_type = :infinite,      reactivation_type = :heterogeneous) =>  :heterogeneous_activation,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :heterogeneous,  deactivation_type = :infinite,      reactivation_type = :instantaneous) =>  :heterogeneous_activation,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :heterogeneous,  deactivation_type = :heterogeneous, reactivation_type = :infinite) =>       :oscillation, # :stochastic_switching,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :heterogeneous,  deactivation_type = :heterogeneous, reactivation_type = :heterogeneous) =>  :stochastic_pulsing_no_initial_pulse,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :heterogeneous,  deactivation_type = :heterogeneous, reactivation_type = :instantaneous) =>  :oscillation,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :heterogeneous,  deactivation_type = :instantaneous, reactivation_type = :infinite) =>       :oscillation,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :heterogeneous,  deactivation_type = :instantaneous, reactivation_type = :heterogeneous) =>  :stochastic_pulsing_no_initial_pulse,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :heterogeneous,  deactivation_type = :instantaneous, reactivation_type = :instantaneous) =>  :oscillation,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :instantaneous,  deactivation_type = :infinite,      reactivation_type = :heterogeneous) =>  :homogeneous_activation,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :instantaneous,  deactivation_type = :infinite,      reactivation_type = :instantaneous) =>  :homogeneous_activation,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :instantaneous,  deactivation_type = :heterogeneous, reactivation_type = :infinite) =>       :oscillation, # :stochastic_switching_instant_initial_activation,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :instantaneous,  deactivation_type = :heterogeneous, reactivation_type = :heterogeneous) =>  :oscillation, # :stochastic_switching_instant_initial_activation,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :instantaneous,  deactivation_type = :heterogeneous, reactivation_type = :instantaneous) =>  :oscillation, # :stochastic_anti_pulsing_bistable_oscillation,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :instantaneous,  deactivation_type = :instantaneous, reactivation_type = :heterogeneous) =>  :oscillation, # :stochastic_pulsing_bistable_oscillation_initial_pulse,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :instantaneous,  deactivation_type = :instantaneous, reactivation_type = :instantaneous) =>  :oscillation,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :pulse,          deactivation_type = :infinite,      reactivation_type = :heterogeneous) =>  :homogeneous_activation,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :pulse,          deactivation_type = :infinite,      reactivation_type = :instantaneous) =>  :homogeneous_activation,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :pulse,          deactivation_type = :heterogeneous, reactivation_type = :infinite) =>       :oscillation_bistable, # :stochastic_switching_instant_initial_activation,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :pulse,          deactivation_type = :heterogeneous, reactivation_type = :heterogeneous) =>  :oscillation,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :pulse,          deactivation_type = :heterogeneous, reactivation_type = :instantaneous) =>  :stochastic_anti_pulsing_bistable_oscillation,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :pulse,          deactivation_type = :instantaneous, reactivation_type = :infinite) =>       :oscillation_bistable,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :pulse,          deactivation_type = :instantaneous, reactivation_type = :heterogeneous) =>  :oscillation_bistable, # :stochastic_pulsing_bistable_oscillation_initial_pulse,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :pulse,          deactivation_type = :instantaneous, reactivation_type = :instantaneous) =>  :oscillation_bistable,
    
    (fp_type = :oscillation_active_ss, initial_activation_type = :heterogeneous,    deactivation_type = :infinite,      reactivation_type = :NA) => :heterogeneous_activation_monostable,
    (fp_type = :oscillation_active_ss, initial_activation_type = :heterogeneous,    deactivation_type = :heterogeneous, reactivation_type = :NA) => :oscillation, # :stochastic_anti_pulsing,
    (fp_type = :oscillation_active_ss, initial_activation_type = :instantaneous,    deactivation_type = :infinite,      reactivation_type = :NA) => :homogeneous_activation,
    (fp_type = :oscillation_active_ss, initial_activation_type = :instantaneous,    deactivation_type = :heterogeneous, reactivation_type = :NA) => :oscillation, # :stochastic_anti_pulsing,
    (fp_type = :oscillation_active_ss, initial_activation_type = :instantaneous,    deactivation_type = :instantaneous, reactivation_type = :NA) => :regular_anti_pulsing,
    (fp_type = :oscillation_active_ss, initial_activation_type = :pulse,            deactivation_type = :infinite,      reactivation_type = :NA) => :homogeneous_activation,
    (fp_type = :oscillation_active_ss, initial_activation_type = :pulse,            deactivation_type = :heterogeneous, reactivation_type = :NA) => :stochastic_anti_pulsing,
    (fp_type = :oscillation_active_ss, initial_activation_type = :pulse,            deactivation_type = :instantaneous, reactivation_type = :NA) => :regular_anti_pulsing,
    
    (fp_type = :intermediate_activation_inactive_ss, initial_activation_type = :NA,             deactivation_type = :NA, reactivation_type = :infinite) =>      :no_activation,
    (fp_type = :intermediate_activation_inactive_ss, initial_activation_type = :NA,             deactivation_type = :NA, reactivation_type = :heterogeneous) => :stochastic_pulsing,
    (fp_type = :intermediate_activation_inactive_ss, initial_activation_type = :NA,             deactivation_type = :NA, reactivation_type = :instantaneous) => :homogeneous_intermediate_activation,
    (fp_type = :intermediate_activation_inactive_ss, initial_activation_type = :infinite,       deactivation_type = :NA, reactivation_type = :infinite) =>      :no_activation,
    (fp_type = :intermediate_activation_inactive_ss, initial_activation_type = :infinite,       deactivation_type = :NA, reactivation_type = :heterogeneous) => :stochastic_pulsing_no_initial_pulse,
    (fp_type = :intermediate_activation_inactive_ss, initial_activation_type = :heterogeneous,  deactivation_type = :NA, reactivation_type = :infinite) =>      :stochastic_pulsing_no_initial_pulse,
    (fp_type = :intermediate_activation_inactive_ss, initial_activation_type = :heterogeneous,  deactivation_type = :NA, reactivation_type = :heterogeneous) => :stochastic_pulsing_no_initial_pulse,
    (fp_type = :intermediate_activation_inactive_ss, initial_activation_type = :heterogeneous,  deactivation_type = :NA, reactivation_type = :instantaneous) => :homogeneous_intermediate_activation,
    (fp_type = :intermediate_activation_inactive_ss, initial_activation_type = :instantaneous,  deactivation_type = :NA, reactivation_type = :infinite) =>      :no_activation,
    (fp_type = :intermediate_activation_inactive_ss, initial_activation_type = :instantaneous,  deactivation_type = :NA, reactivation_type = :heterogeneous) => :stochastic_pulsing_initial_pulse,
    (fp_type = :intermediate_activation_inactive_ss, initial_activation_type = :instantaneous,  deactivation_type = :NA, reactivation_type = :instantaneous) => :homogeneous_intermediate_activation,
    (fp_type = :intermediate_activation_inactive_ss, initial_activation_type = :pulse,          deactivation_type = :NA, reactivation_type = :infinite) =>      :single_response_pulse,
    (fp_type = :intermediate_activation_inactive_ss, initial_activation_type = :pulse,          deactivation_type = :NA, reactivation_type = :heterogeneous) => :stochastic_pulsing_initial_pulse,
    (fp_type = :intermediate_activation_inactive_ss, initial_activation_type = :pulse,          deactivation_type = :NA, reactivation_type = :instantaneous) => :homogeneous_intermediate_activation,

    (fp_type = :intermediate_activation_bistable_ss, initial_activation_type = :infinite,       deactivation_type = :heterogeneous, reactivation_type = :infinite) =>       :no_activation,
    (fp_type = :intermediate_activation_bistable_ss, initial_activation_type = :infinite,       deactivation_type = :heterogeneous, reactivation_type = :heterogeneous) =>  :homogeneous_intermediate_activation, # :oscillation_bistable,  # :stochastic_switching,
    (fp_type = :intermediate_activation_bistable_ss, initial_activation_type = :infinite,       deactivation_type = :instantaneous, reactivation_type = :heterogeneous) =>  :stochastic_pulsing_no_initial_pulse,
    (fp_type = :intermediate_activation_bistable_ss, initial_activation_type = :infinite,       deactivation_type = :instantaneous, reactivation_type = :infinite) =>       :no_activation,
    (fp_type = :intermediate_activation_bistable_ss, initial_activation_type = :heterogeneous,  deactivation_type = :infinite,      reactivation_type = :heterogeneous) =>  :heterogeneous_activation,
    (fp_type = :intermediate_activation_bistable_ss, initial_activation_type = :heterogeneous,  deactivation_type = :infinite,      reactivation_type = :instantaneous) =>  :heterogeneous_activation,
    (fp_type = :intermediate_activation_bistable_ss, initial_activation_type = :heterogeneous,  deactivation_type = :heterogeneous, reactivation_type = :infinite) =>       :homogeneous_intermediate_activation, # :oscillation_bistable,  # :stochastic_switching,
    (fp_type = :intermediate_activation_bistable_ss, initial_activation_type = :heterogeneous,  deactivation_type = :heterogeneous, reactivation_type = :heterogeneous) =>  :stochastic_pulsing_no_initial_pulse,
    (fp_type = :intermediate_activation_bistable_ss, initial_activation_type = :heterogeneous,  deactivation_type = :instantaneous, reactivation_type = :infinite) =>       :stochastic_pulsing_no_initial_pulse,
    (fp_type = :intermediate_activation_bistable_ss, initial_activation_type = :heterogeneous,  deactivation_type = :instantaneous, reactivation_type = :heterogeneous) =>  :stochastic_pulsing_bistable_intermediate_activation_no_initial_pulse,
    (fp_type = :intermediate_activation_bistable_ss, initial_activation_type = :instantaneous,  deactivation_type = :infinite,      reactivation_type = :heterogeneous) =>  :homogeneous_activation,    
    (fp_type = :intermediate_activation_bistable_ss, initial_activation_type = :instantaneous,  deactivation_type = :infinite,      reactivation_type = :instantaneous) =>  :homogeneous_activation,
    (fp_type = :intermediate_activation_bistable_ss, initial_activation_type = :instantaneous,  deactivation_type = :heterogeneous, reactivation_type = :infinite) =>       :homogeneous_intermediate_activation, # :oscillation_bistable,  # :stochastic_switching_instant_initial_activation,
    (fp_type = :intermediate_activation_bistable_ss, initial_activation_type = :instantaneous,  deactivation_type = :heterogeneous, reactivation_type = :heterogeneous) =>  :homogeneous_intermediate_activation, # :oscillation_bistable,  # :stochastic_switching_instant_initial_activation,
    (fp_type = :intermediate_activation_bistable_ss, initial_activation_type = :instantaneous,  deactivation_type = :heterogeneous, reactivation_type = :instantaneous) =>  :homogeneous_intermediate_activation, # :oscillation_bistable,  # :stochastic_anti_pulsing_bistable_intermediate_activation,
    (fp_type = :intermediate_activation_bistable_ss, initial_activation_type = :instantaneous,  deactivation_type = :instantaneous, reactivation_type = :heterogeneous) =>  :homogeneous_intermediate_activation, # :oscillation_bistable,  # :stochastic_pulsing_bistable_intermediate_activation_initial_pulse,
    (fp_type = :intermediate_activation_bistable_ss, initial_activation_type = :instantaneous,  deactivation_type = :instantaneous, reactivation_type = :instantaneous) =>  :homogeneous_intermediate_activation, # :oscillation_bistable,    
    (fp_type = :intermediate_activation_bistable_ss, initial_activation_type = :pulse,          deactivation_type = :infinite,      reactivation_type = :heterogeneous) =>  :homogeneous_activation,
    (fp_type = :intermediate_activation_bistable_ss, initial_activation_type = :pulse,          deactivation_type = :infinite,      reactivation_type = :instantaneous) =>  :homogeneous_activation,
    (fp_type = :intermediate_activation_bistable_ss, initial_activation_type = :pulse,          deactivation_type = :heterogeneous, reactivation_type = :infinite) =>       :homogeneous_intermediate_activation, # :oscillation_bistable,  # :stochastic_switching_instant_initial_activation,
    (fp_type = :intermediate_activation_bistable_ss, initial_activation_type = :pulse,          deactivation_type = :heterogeneous, reactivation_type = :heterogeneous) =>  :homogeneous_intermediate_activation, # :oscillation_bistable,  # :stochastic_switching_instant_initial_activation,
    (fp_type = :intermediate_activation_bistable_ss, initial_activation_type = :pulse,          deactivation_type = :heterogeneous, reactivation_type = :instantaneous) =>  :stochastic_anti_pulsing_bistable_intermediate_activation,
    (fp_type = :intermediate_activation_bistable_ss, initial_activation_type = :pulse,          deactivation_type = :instantaneous, reactivation_type = :infinite) =>       :single_response_pulse,
    (fp_type = :intermediate_activation_bistable_ss, initial_activation_type = :pulse,          deactivation_type = :instantaneous, reactivation_type = :heterogeneous) =>  :stochastic_pulsing_initial_pulse,
    (fp_type = :intermediate_activation_bistable_ss, initial_activation_type = :pulse,          deactivation_type = :instantaneous, reactivation_type = :instantaneous) =>  :stochastic_pulsing_initial_pulse,
    
    (fp_type = :intermediate_activation_intermediary_ss, initial_activation_type = :infinite,       deactivation_type = :NA, reactivation_type = :NA) =>    :no_activation,
    (fp_type = :intermediate_activation_intermediary_ss, initial_activation_type = :heterogeneous,  deactivation_type = :NA, reactivation_type = :NA) =>    :heterogeneous_intermediate_activation,
    (fp_type = :intermediate_activation_intermediary_ss, initial_activation_type = :instantaneous,  deactivation_type = :NA, reactivation_type = :NA) =>    :homogeneous_intermediate_activation,
    (fp_type = :intermediate_activation_intermediary_ss, initial_activation_type = :pulse,          deactivation_type = :NA, reactivation_type = :NA) =>    :homogeneous_intermediate_activation,
    
    (fp_type = :intermediate_activation_active_ss, initial_activation_type = :heterogeneous,    deactivation_type = :infinite,      reactivation_type = :NA) => :heterogeneous_activation_monostable,
    (fp_type = :intermediate_activation_active_ss, initial_activation_type = :heterogeneous,    deactivation_type = :heterogeneous, reactivation_type = :NA) => :stochastic_anti_pulsing,
    (fp_type = :intermediate_activation_active_ss, initial_activation_type = :instantaneous,    deactivation_type = :infinite,      reactivation_type = :NA) => :homogeneous_activation,
    (fp_type = :intermediate_activation_active_ss, initial_activation_type = :instantaneous,    deactivation_type = :heterogeneous, reactivation_type = :NA) => :stochastic_anti_pulsing,
    (fp_type = :intermediate_activation_active_ss, initial_activation_type = :instantaneous,    deactivation_type = :instantaneous, reactivation_type = :NA) => :homogeneous_intermediate_activation, # :oscillation, # :regular_anti_pulsing,
    (fp_type = :intermediate_activation_active_ss, initial_activation_type = :pulse,            deactivation_type = :infinite,      reactivation_type = :NA) => :homogeneous_activation,
    (fp_type = :intermediate_activation_active_ss, initial_activation_type = :pulse,            deactivation_type = :heterogeneous, reactivation_type = :NA) => :stochastic_anti_pulsing,
    (fp_type = :intermediate_activation_active_ss, initial_activation_type = :pulse,            deactivation_type = :instantaneous, reactivation_type = :NA) => :homogeneous_intermediate_activation, # :oscillation, # :regular_anti_pulsing,
    
    # Remove these.
    (fp_type = :low_freq_intermediary_ss, initial_activation_type = :instantaneous, deactivation_type = :heterogeneous, reactivation_type = :heterogeneous) => :homogeneous_intermediate_activation,
    (fp_type = :low_freq_intermediary_ss, initial_activation_type = :pulse, deactivation_type = :heterogeneous, reactivation_type = :instantaneous) => :homogeneous_intermediate_activation,
    (fp_type = :low_freq_intermediary_ss, initial_activation_type = :instantaneous, deactivation_type = :instantaneous, reactivation_type = :heterogeneous) => :homogeneous_intermediate_activation,
    (fp_type = :low_freq_intermediary_ss, initial_activation_type = :pulse, deactivation_type = :heterogeneous, reactivation_type = :heterogeneous) => :homogeneous_intermediate_activation,
    (fp_type = :low_freq_intermediary_ss, initial_activation_type = :instantaneous, deactivation_type = :heterogeneous, reactivation_type = :instantaneous) => :homogeneous_intermediate_activation,
    (fp_type = :low_freq_intermediary_ss, initial_activation_type = :instantaneous, deactivation_type = :infinite, reactivation_type = :infinite) => :homogeneous_intermediate_activation,
    (fp_type = :low_freq_intermediary_ss, initial_activation_type = :instantaneous, deactivation_type = :instantaneous, reactivation_type = :infinite) => :homogeneous_intermediate_activation,
    (fp_type = :low_freq_intermediary_ss, initial_activation_type = :instantaneous, deactivation_type = :heterogeneous, reactivation_type = :infinite) =>:homogeneous_intermediate_activation,
    (fp_type = :low_freq_intermediary_ss, initial_activation_type = :pulse, deactivation_type = :infinite, reactivation_type = :instantaneous) => :homogeneous_intermediate_activation,
    (fp_type = :low_freq_intermediary_ss, initial_activation_type = :pulse, deactivation_type = :infinite, reactivation_type = :infinite) => :homogeneous_intermediate_activation,
    (fp_type = :low_freq_intermediary_ss, initial_activation_type = :pulse, deactivation_type = :infinite, reactivation_type = :heterogeneous) => :homogeneous_intermediate_activation,
    (fp_type = :low_freq_intermediary_ss, initial_activation_type = :pulse, deactivation_type = :instantaneous, reactivation_type = :heterogeneous) => :homogeneous_intermediate_activation,
    (fp_type = :low_freq_intermediary_ss, initial_activation_type = :pulse, deactivation_type = :instantaneous, reactivation_type = :instantaneous) => :homogeneous_intermediate_activation,
    (fp_type = :low_freq_intermediary_ss, initial_activation_type = :instantaneous, deactivation_type = :instantaneous, reactivation_type = :instantaneous) => :homogeneous_intermediate_activation,
    (fp_type = :oscillation_active_ss, initial_activation_type = :heterogeneous, deactivation_type = :instantaneous, reactivation_type = :NA) => :homogeneous_intermediate_activation,
    (fp_type = :oscillation_bistable_ss, initial_activation_type = :infinite, deactivation_type = :instantaneous, reactivation_type = :heterogeneous) => :homogeneous_intermediate_activation,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :infinite, deactivation_type = :infinite, reactivation_type = :heterogeneous) => :homogeneous_intermediate_activation,
    (fp_type = :bistability_intermediary_active, initial_activation_type = :instantaneous, deactivation_type = :infinite, reactivation_type = :infinite) => :homogeneous_intermediate_activation,
    (fp_type = :low_freq_intermediary_ss, initial_activation_type = :instantaneous, deactivation_type = :infinite, reactivation_type = :instantaneous) => :homogeneous_intermediate_activation,
    (fp_type = :low_freq_intermediary_ss, initial_activation_type = :instantaneous, deactivation_type = :instantaneous, reactivation_type = :instantaneous) => :homogeneous_intermediate_activation,
    (fp_type = :low_freq_intermediary_ss, initial_activation_type = :pulse, deactivation_type = :heterogeneous, reactivation_type = :infinite) => :homogeneous_intermediate_activation,
    (fp_type = :low_freq_intermediary_ss, initial_activation_type = :pulse, deactivation_type = :instantaneous, reactivation_type = :infinite) => :homogeneous_intermediate_activation,
    (fp_type = :low_freq_intermediary_ss, initial_activation_type = :instantaneous, deactivation_type = :infinite, reactivation_type = :heterogeneous) => :homogeneous_intermediate_activation,
    (fp_type = :low_freq_intermediary_ss, initial_activation_type = :pulse, deactivation_type = :instantaneous, reactivation_type = :instantaneous) => :homogeneous_intermediate_activation,

    (fp_type = :low_freq_inactive_ss,           initial_activation_type = :NA, deactivation_type = :NA, reactivation_type = :NA) => :no_activation,
    (fp_type = :low_freq_intermediary_ss,       initial_activation_type = :NA, deactivation_type = :NA, reactivation_type = :NA) => :homogeneous_intermediate_activation,
    (fp_type = :low_freq_active_ss,             initial_activation_type = :NA, deactivation_type = :NA, reactivation_type = :NA) => :homogeneous_activation,
    
    (fp_type = :tri_unstable_inactive_ss,       initial_activation_type = :NA, deactivation_type = :NA, reactivation_type = :NA) => :tri_unstable,
    (fp_type = :tri_unstable_intermediary_ss,   initial_activation_type = :NA, deactivation_type = :NA, reactivation_type = :NA) => :tri_unstable,
    (fp_type = :tri_unstable_active_ss,         initial_activation_type = :NA, deactivation_type = :NA, reactivation_type = :NA) => :tri_unstable,
    (fp_type = :tri_unstable_bistable_ss,       initial_activation_type = :NA, deactivation_type = :NA, reactivation_type = :NA) => :tri_unstable,
    
    (fp_type = :inactive_leng_1_ncminmax,       initial_activation_type = :NA, deactivation_type = :NA, reactivation_type = :NA) => :no_activation,
    (fp_type = :active_leng_1_ncminmax,         initial_activation_type = :NA, deactivation_type = :NA, reactivation_type = :NA) => :homogeneous_activation,
    (fp_type = :intermediary_leng_1_ncminmax,   initial_activation_type = :NA, deactivation_type = :NA, reactivation_type = :NA) => :homogeneous_intermediate_activation,

    (fp_type = :auto_no_activation,             initial_activation_type = :NA, deactivation_type = :NA, reactivation_type = :NA) => :no_activation,
    (fp_type = :auto_homogeneous_activation,    initial_activation_type = :NA, deactivation_type = :NA, reactivation_type = :NA) => :homogeneous_activation,       
    (fp_type = :unknown_fp_type,                initial_activation_type = :NA, deactivation_type = :NA, reactivation_type = :NA) => :unknown_behaviour,
    (fp_type = :MaxIters,                       initial_activation_type = :NA, deactivation_type = :NA, reactivation_type = :NA) => :max_iters,
    (fp_type = :ConvergenceFailure,             initial_activation_type = :NA, deactivation_type = :NA, reactivation_type = :NA) => :convergence_failure])
           

# Maps the detailed behaviours to more "pure" ones.
const known_behaviour_list_short = Dict([ 
    :no_activation =>                                                       :no_activation,
    :single_response_pulse =>                                               :single_response_pulse,
    :stochastic_pulsing =>                                                  :stochastic_pulsing,
    :stochastic_pulsing_initial_pulse =>                                    :stochastic_pulsing,
    :stochastic_pulsing_no_initial_pulse =>                                 :stochastic_pulsing,
    :stochastic_pulsing_bistable_initial_pulse =>                           :stochastic_pulsing,
    :stochastic_pulsing_bistable_no_initial_pulse =>                        :stochastic_pulsing,
    :stochastic_pulsing_bistable_oscillation_initial_pulse =>               :stochastic_pulsing,
    :stochastic_pulsing_bistable_oscillation_no_initial_pulse =>            :stochastic_pulsing,
    :stochastic_pulsing_bistable_intermediate_activation_initial_pulse =>   :stochastic_pulsing,
    :stochastic_pulsing_bistable_intermediate_activation_no_initial_pulse =>:stochastic_pulsing,
    :regular_pulsing =>                                                     :oscillation,      
    :oscillation =>                                                         :oscillation,
    :oscillation_bistable =>                                                :oscillation,
    :regular_anti_pulsing =>                                                :oscillation,      
    :regular_anti_pulsing_no_initial_activation =>                          :oscillation,       
    :tri_unstable =>                                                        :oscillation,      
    :stochastic_anti_pulsing =>                                             :stochastic_anti_pulsing,
    :stochastic_anti_pulsing_no_initial_activation =>                       :stochastic_anti_pulsing,
    :stochastic_anti_pulsing_bistable =>                                    :stochastic_anti_pulsing,
    :stochastic_anti_pulsing_bistable_no_initial_activation =>              :stochastic_anti_pulsing,
    :stochastic_anti_pulsing_bistable_oscillation =>                        :stochastic_anti_pulsing,
    :stochastic_anti_pulsing_bistable_intermediate_activation =>            :stochastic_anti_pulsing,
    :homogeneous_activation =>                                              :homogeneous_activation,
    :heterogeneous_activation =>                                            :heterogeneous_activation,
    :heterogeneous_activation_monostable =>                                 :homogeneous_activation, # empiric, n=1.
    :stochastic_switching =>                                                :stochastic_switching,
    :stochastic_switching_instant_initial_activation =>                     :stochastic_switching,
    :stable_bistability =>                                                  :stable_bistability,
    :homogeneous_intermediate_activation =>                                 :intermediate_activation,
    :homogeneous_intermediate_activation_bistable =>                        :intermediate_activation,
    :heterogeneous_intermediate_activation =>                               :intermediate_activation,  # Very few cases exists (and also quite homogeneous). Or maybe not actually...
    :heterogeneous_intermediate_activation_bistable =>                      :intermediate_activation,  # Very few cases exists (and also quite homogeneous). Or maybe not actually...
    :tri_unstable =>                                                        :oscillation, # Empiric, low count. a guess. Check.
    :unclassified_behaviour =>                                              :unclassified_behaviour,
    :no_default_behaviour =>                                                :unclassified_behaviour,
    :unknown_behaviour =>                                                   :unknown_behaviour,
    :max_iters =>                                                           :max_iters,
    :convergence_failure =>                                                 :convergence_failure])